from twilio.base import deserialize as deserialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from twilio.rest.sync.v1.service.sync_map.sync_map_item import SyncMapItemList as SyncMapItemList
from twilio.rest.sync.v1.service.sync_map.sync_map_permission import SyncMapPermissionList as SyncMapPermissionList
from typing import Any, Optional

class SyncMapList(ListResource):
    def __init__(self, version: Any, service_sid: Any) -> None: ...
    def create(self, unique_name: Any = ..., ttl: Any = ..., collection_ttl: Any = ...): ...
    def stream(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def list(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def page(self, page_token: Any = ..., page_number: Any = ..., page_size: Any = ...): ...
    def get_page(self, target_url: Any): ...
    def get(self, sid: Any): ...
    def __call__(self, sid: Any): ...

class SyncMapPage(Page):
    def __init__(self, version: Any, response: Any, solution: Any) -> None: ...
    def get_instance(self, payload: Any): ...

class SyncMapContext(InstanceContext):
    def __init__(self, version: Any, service_sid: Any, sid: Any) -> None: ...
    def fetch(self): ...
    def delete(self): ...
    def update(self, ttl: Any = ..., collection_ttl: Any = ...): ...
    @property
    def sync_map_items(self): ...
    @property
    def sync_map_permissions(self): ...

class SyncMapInstance(InstanceResource):
    def __init__(self, version: Any, payload: Any, service_sid: Any, sid: Optional[Any] = ...) -> None: ...
    @property
    def sid(self): ...
    @property
    def unique_name(self): ...
    @property
    def account_sid(self): ...
    @property
    def service_sid(self): ...
    @property
    def url(self): ...
    @property
    def links(self): ...
    @property
    def revision(self): ...
    @property
    def date_expires(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def created_by(self): ...
    def fetch(self): ...
    def delete(self): ...
    def update(self, ttl: Any = ..., collection_ttl: Any = ...): ...
    @property
    def sync_map_items(self): ...
    @property
    def sync_map_permissions(self): ...
