from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from typing import Any, Optional

class WebhookList(ListResource):
    def __init__(self, version: Any, service_sid: Any) -> None: ...
    def create(self, friendly_name: Any, event_types: Any, webhook_url: Any, status: Any = ...): ...
    def stream(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def list(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def page(self, page_token: Any = ..., page_number: Any = ..., page_size: Any = ...): ...
    def get_page(self, target_url: Any): ...
    def get(self, sid: Any): ...
    def __call__(self, sid: Any): ...

class WebhookPage(Page):
    def __init__(self, version: Any, response: Any, solution: Any) -> None: ...
    def get_instance(self, payload: Any): ...

class WebhookContext(InstanceContext):
    def __init__(self, version: Any, service_sid: Any, sid: Any) -> None: ...
    def update(self, friendly_name: Any = ..., event_types: Any = ..., webhook_url: Any = ..., status: Any = ...): ...
    def delete(self): ...
    def fetch(self): ...

class WebhookInstance(InstanceResource):
    class Status:
        ENABLED: str = ...
        DISABLED: str = ...
    class Methods:
        GET: str = ...
        POST: str = ...
    def __init__(self, version: Any, payload: Any, service_sid: Any, sid: Optional[Any] = ...) -> None: ...
    @property
    def sid(self): ...
    @property
    def service_sid(self): ...
    @property
    def account_sid(self): ...
    @property
    def friendly_name(self): ...
    @property
    def event_types(self): ...
    @property
    def status(self): ...
    @property
    def webhook_url(self): ...
    @property
    def webhook_method(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def url(self): ...
    def update(self, friendly_name: Any = ..., event_types: Any = ..., webhook_url: Any = ..., status: Any = ...): ...
    def delete(self): ...
    def fetch(self): ...
